\chapter{Shaping the acoustic field}
\label{chap:optimization}

In this chapter, I present the mathematical model of the acoustic field, explain why it is necessary to use numerical optimization, formulate the optimization problems and algorithms for solving them.

\section{Model of the acoustic field}

In the previous chapter, I stated that the ultrasonic transducers are driven by phase-shifted signals.
In this section, I explain how the different phase-shifts affect the shape of the acoustic field.

The mathematical model, which describes the field, uses acoustic pressure in complex phasor notation.
When calculating the total acoustic pressure, $P$, at a given point, $(x,y,z)$, with a given vector of phase-shifts, $\grvect{\Phi} = \left[ \varphi_1, \ldots, \varphi_N \right]$, I assume the principle of superposition:
\begin{equation}
    \label{eq:total_pressure}
    P(x,y,z,\grvect{\Phi}) = \sum_{i=1}^N P^{(i)} (x,y,z,\varphi_i)\,,
\end{equation}
where $P^{(i)} (x,y,z,\varphi_i)$ is the contribution from the $i^{\mathrm{th}}$ transducer. This contribution is expressed as a product of position- and phase-shift-dependent parts:
\begin{equation}
    \label{eq:pressure_single_transducer}
    P^{(i)}(x,y,z,\varphi_i) = M^{(i)}(x,y,z) \, \e^{\imag \varphi_i}\,.
\end{equation}
Model of the position-dependent part used in this thesis was proposed in \cite{marzo_ghost_2015}, and is defined as:
\begin{equation}
    \label{eq:position_dependent}
    M^{(i)}(x,y,z) = P_0 \, f_{dir}(x,y,z) \, \frac{1}{d} \, \e^{\imag k d}\,,
\end{equation}
where $P_0$ is the nominal pressure at the distance of \SI{1}{\metre}, $f_{dir}$ is the so-called directivity function, $d$ is the distance between the point and the transducer, and $k$ is the wavenumber.

For the directivity function, I employ a far-field model of a vibrating piston source \cite[p. 179-182]{kinsler_fundamentals_2000} \footnote{Due to the high computational cost of evaluating the Bessel function, the directivity in the actual algorithm is pre-computed at several given points and then approximated by linear interpolation.}:
\begin{equation}
    \label{eq:directivity}
    f_{dir} = \frac{2\,\bessel{1}(k\,r\,\sin \theta)}{k\,r\,\sin \theta}\,,
\end{equation}
where $r$ is the radius of the transducer, $\bessel{1}$ is the first-order Bessel function of the first kind, and $\theta$ is the angle between the vertical axis of the transducer and the transducer-point connector.
Assuming that the coordinate system is centered at the transducer, the sine of $\theta$ is equal to
\begin{equation}
    \label{eq:sin_theta}
    \sin \theta = \frac{\sqrt{x^2 + y^2}}{d} = \sqrt{\frac{x^2+y^2}{x^2+y^2+z^2}}\,.
\end{equation}


\section{Formulating the optimization problem}

While it is relatively straightforward to calculate the shape of the acoustic field generated by a given set of phase-shifts, the inverse problem (\abbrv{i.e.}, finding phase-shifts that generate a prescribed acoustic field) is far from being trivial, and to my best knowledge, it does not have a closed-form solution.

Objects exposed to the acoustic field tend to move from high-pressure to low-pressure areas.
For the purpose of manipulation, it is desirable to create areas with different pressure, which push the objects.
To shape the acoustic field, it is necessary to use numerical optimization with a carefully selected criterion.
I have explored three possible criteria for this optimization problem.

\subsection{Amplitude fitting}
The phase of the acoustic pressure has no observable effect on objects placed in the field.
It is, therefore, sufficient to consider only the amplitude.

The simplest criterion, which I already used in my Bachelor's thesis, is defined as follows:
Let there be $n$ points, $(x_1,y_1,z_1),\ldots,(x_n,y_n,z_n)$, with desired amplitudes, $A_1,\ldots,A_n$.
The optimal phase-shifts are obtained by solving a nonlinear least squares problem:
\begin{equation}
    \grvect{\Phi}^* = \argmin_{\grvect{\Phi} \in \mathbb{R}^N} \nsum[1.2]_{i=1}^n \left( \left|P(x_i,y_i,z_i,\grvect{\Phi})\right|^2 - A_i^2 \right)^2\,.
    \label{eq:crit1}
\end{equation}
The amplitude of the total acoustic pressure is squared, because it is actually easier to calculate the square than the amplitude itself.
An efficient formula for calculating the amplitude is presented in Appendix~\ref{sec:modulus}.

\subsection{Local maximum constraint}
\label{sec:loc_max_const}

Having a prescribed amplitude at a given point is often not sufficient.
To have the desired effect on the manipulated object, the specified point must also be a local maximum.

The correct way of ensuring that the specified point is a local maximum would be to minimize eigenvalues of the spatial Hessian matrix (which is equivalent to minimizing the sum of the second spatial derivatives of the acoustic pressure) and simultaneously have the spatial gradient equal to zero.
Unfortunately, calculating the second spatial derivatives is computationally prohibitive.

A computationally manageable criterion uses only the first-order condition for a local extreme:
\begin{equation}
    \begin{split}
        \grvect{\Phi}^* = \argmin_{\grvect{\Phi} \in \mathbb{R}^N} \nsum[2]_{i=1}^n \Bigg[& w_p\,\left( \left|P(x_i,y_i,z_i,\grvect{\Phi})\right|^2 - A_i^2 \right)^2 + \\
        &\left( \frac{\partial \left|P(x_i,y_i,z_i,\grvect{\Phi})\right|^2}{\partial x} \right)^2 +
        \left( \frac{\partial \left|P(x_i,y_i,z_i,\grvect{\Phi})\right|^2}{\partial y} \right)^2 \Bigg]\,,
    \end{split}    
    \label{eq:crit2}
\end{equation}
where $w_p$ is a weight that allows to adjust the trade-off between having the required amplitude and having zero gradient.
Since the movement of objects is restricted to the $xy$ plane, minimizing the spatial derivative with respect to $z$ is not necessary.
An efficient formula for calculating the spatial derivatives is presented in Appendix~\ref{sec:spatial_derivative}.

Compared to criterion in \eqref{eq:crit1}, this criterion attempts to achieve a local maximum by minimizing the square of the spatial derivatives.
This approach does not guarantee a local maximum (in fact, it can also result in a local minimum or a saddle point).
However, thanks to the nature of the underlying mathematical model, minimizing this criterion results in a local maximum if the specified amplitude is high enough.

\subsection{Gradient fitting}
A different approach to creating high- and low-pressure areas is based on the assumption that the pressure difference between these zones is proportional to the steepness of the acoustic pressure gradient.
The criterion is defined as follows:
Let there be $n$ points, $(x_1,y_1,z_1),\ldots,(x_n,y_n,z_n)$, with desired value of spatial derivatives, $(P_{x_1},P_{y_1}),\ldots,(P_{x_n},P_{y_n})$.
The optimal phase-shifts are obtained by solving a nonlinear least squares problem:
\begin{equation}
    %\begin{split}
        \grvect{\Phi}^* = \argmin_{\grvect{\Phi} \in \mathbb{R}^N} \nsum[2]_{i=1}^n \left[ 
            \left( \frac{\partial \left|P(x_i,y_i,z_i,\grvect{\Phi})\right|^2}{\partial x} - P_{x_i} \right)^2 + 
            \left( \frac{\partial \left|P(x_i,y_i,z_i,\grvect{\Phi})\right|^2}{\partial y} - P_{y_i} \right)^2 \right]\,.
    %\end{split}    
    \label{eq:crit3}
\end{equation}

Unlike the two previous criteria, the amplitude of the acoustic pressure is not considered here.
This can lead to potential issues if the resulting amplitude is too high, as high-amplitude acoustic pressure can break the surface tension of water and create bubbles.

\section{Optimization algorithm}

All three criteria listed above lead to nonlinear least squares problems.
There are various methods for solving this class of problems\cite{NLS}; one of them is the Levenberg-Marquardt (LM) algorithm.

The LM algorithm is used to solve a nonlinear least squares problem, which is generally defined as:
\begin{equation}
    \vect{p}^* = \argmin_{\vect{p}} \left\| f(\vect{p}) - \vect{y} \right\|_2^2\,,
\end{equation}
where $\vect{p}$ is the vector of free variables (in the acoustic field shaping problem, $\vect{p}$ would be the vector of phase-shifts), $f$ is the nonlinear function, $\vect{y}$ is the vector of fitted values, and $\|.\|_2$ represents the Euclidian norm of a vector.

The LM algorithm is iterative; in every iteration, the estimate $\vect{p}$ is updated by adding a vector $\grvect{\delta}_{\vect{p}}$.
The value of $\grvect{\delta}_{\vect{p}}$ is determined by solving a set of linear equations:
\begin{equation}
    \left( \mat{J}^{\rm T}\,\mat{J} + \mu\,\mat{I}_N \right)\,\grvect{\delta}_{\vect{p}} = - \mat{J}^{\rm T}\,\left( f(\vect{p}) - \vect{y} \right)\,,
    \label{eq:step}
\end{equation}
where $\mat{J}$ is the Jacobian matrix of $f$, $\mat{I}_N$ is an $N \times N$ identity matrix, and $\mu$ is a damping coefficient.
The value of $\mu$ changes depending on the performance of the algorithm --- it increases when the algorithm fails to converge and decreases otherwise.

The set of equations in \eqref{eq:step} is in a form that can be efficiently solved using a `kernel trick,' described in \cite[p.~332]{boyd_algebra_2018}.
The kernel trick lowers the complexity of solving \eqref{eq:step} by transforming the original system of $N$ equations and $N$ unknowns to a smaller system of $n$ equations with $n$ unknowns.
Formally, the solution can be expressed as:
\begin{equation}
    \grvect{\delta}_{\vect{p}} = - \left( \mat{J}^{\rm T}\,\mat{J} + \mu\,\mat{I}_N \right)^{-1}\,\mat{J}^{\rm T}\,\left( f(\vect{p}) - \vect{y} \right)\,.
    \label{eq:step_soln1}
\end{equation}
The following identity
\begin{equation}
    \left( \mat{J}^{\rm T}\,\mat{J} + \mu\,\mat{I}_N \right)^{-1}\,\mat{J}^{\rm T} = \mat{J}^{\rm T}\,\left( \mat{J}\,\mat{J}^{\rm T} + \mu\,\mat{I}_n \right)^{-1}\,,
\end{equation}
holds true for any matrix $\mat{J} \in \mathbb{R}^{n \times N}$ and scalar $\mu > 0$ (proof in \cite[p.~333]{boyd_algebra_2018}).
This identity can be substituted to \eqref{eq:step_soln1} to obtain
\begin{equation}
    \grvect{\delta}_{\vect{p}} = - \mat{J}^{\rm T}\,\left( \mat{J}\,\mat{J}^{\rm T} + \mu\,\mat{I}_n \right)^{-1}\,\left( f(\vect{p}) - \vect{y} \right)\,,
    \label{eq:step_soln2}
\end{equation}
where we need to invert a smaller $n$-by-$n$ matrix instead of the original $N$-by-$N$ matrix in \eqref{eq:step_soln1}.
Furthmore, we can make use of the special structure of the underlying linear system of equations in \eqref{eq:step_soln2} and solve the system efficiently by QR factorizaion.
First, let us define a stacked matrix
\begin{equation}
    \bar{\mat{J}} = \begin{bmatrix} \mat{J}^{\rm T} \\ \sqrt{\mu}\,\mat{I}_n \end{bmatrix}\,.
\end{equation}
The following identity holds true for the stacked matrix
\begin{equation}
    \bar{\mat{J}}^{\rm T}\,\bar{\mat{J}} = \mat{J}\,\mat{J}^{\rm T} + \mu\,\mat{I}_n\,.
    \label{eq:JJidentity}
\end{equation}
%and decompose it into an orthogonal matrix $\mat{Q}$ and an upper triangular matrix $\mat{R}$, so that $\mat{Q}\,\mat{R} = \bar{\mat{J}}$.
Now, let us decompose the matrix $\bar{\mat{J}}$ into QR factors.
The matrix $\bar{\mat{J}}$ has dimensions $(N+n) \times n$.
Therefore, its $\mat{R}$ factor is composed of an $n \times n$ upper triangular matrix $\mat{R}_1$, and an $N \times n$ matrix of zeros.
Thus, the term $\bar{\mat{J}}^{\rm T}\,\bar{\mat{J}}$ can be expressed as
\begin{equation}
    \bar{\mat{J}}^{\rm T}\,\bar{\mat{J}} = \left( \mat{Q}\,\begin{bmatrix} \mat{R}_1 \\ 0 \end{bmatrix} \right)^{\rm T}\,\mat{Q}\,\begin{bmatrix} \mat{R}_1 \\ 0 \end{bmatrix} = \mat{R}_1^{\rm T}\,\mat{R}_1\,.
    \label{eq:JbarQR}
\end{equation}
Combining \eqref{eq:JJidentity} and \eqref{eq:JbarQR} yields the following identity
\begin{equation}
    \mat{J}\,\mat{J}^{\rm T} + \mu\,\mat{I}_n = \mat{R}_1^{\rm T}\,\mat{R}_1\,.
\end{equation}
Substituting this identity into \eqref{eq:step_soln2} yields
\begin{equation}
    \grvect{\delta}_{\vect{p}} = - \mat{J}^{\rm T}\,\mat{R}_1^{-1}\,\mat{R}_1^{\rm -T}\,\left( f(\vect{p}) - \vect{y} \right)\,.
\end{equation}

Solving for $\grvect{\delta}_{\vect{p}}$ using the `kernel trick' has an algorhitmic complexity of $Nn^2$ \cite[p.~333]{boyd_algebra_2018}, while solving the set of $N$ equations defined in \eqref{eq:step} directly has a complexity of $N^3$.
Since $N$ (the number of transducers) is $256$ and $n$ (the number of fitted values) is at most $4$, the kernel trick brings a major improvement over direct calculation.

\section{The resulting shape of the acoustic field}

A comparison between acoustic fields generated by amplitude fitting (\abbrv{i.e.,} by minimizing criterion \eqref{eq:crit1}), and by amplitude fitting with local maximum constraints (\abbrv{i.e.,} by minimizing criterion \eqref{eq:crit2} with $w_p = 1$) is shown in Figures \ref{fig:slices_1} and \ref{fig:slices_2}.
The blue arrows show the direction and magnitude of the spatial derivatives of the acoustic pressure, the green cross marks the desired position of the high-pressure point, and the red circle marks the actual position of the local maximum of acoustic pressure.

\begin{figure}[hb]
    \centering
    \begin{subfigure}[b]{0.49 \textwidth}
        \centering
        \includegraphics[width = \textwidth]{figs/amplitude_fitting_1.eps}
        \caption{The acoustic field shaped by minimizing criterion \eqref{eq:crit1}}
    \end{subfigure}
    \begin{subfigure}[b]{0.49 \textwidth}
        \centering
        \includegraphics[width = \textwidth]{figs/local_maximum_1.eps}
        \caption{The acoustic field shaped by minimizing criterion \eqref{eq:crit2}}
    \end{subfigure}
    \caption{Slices of the acoustic pressure field at $z = \SI{75}{\milli\metre}$. The required amplitude is \SI{2500}{\pascal} at $(x,y,z) = (0,0,75)$.}
    \label{fig:slices_1}
    \vspace{-1.5em}
\end{figure}
\FloatBarrier

If the specified high-pressure point has its $x$- and $y$-coordinates equal to zero, the resulting field has an identical shape, and the specified point is the local maximum in both cases, as shown in \figref{fig:slices_1}.
However, if the specified point is not at the center, the amplitude fitting method does not generate a field, where the specified point is the local maximum. 
This can be seen in \figref{fig:slices_2a}, where the distance between the specified point and the local maximum is approximately $2$ millimeters.
Figure \ref{fig:slices_2b} shows that this issue is solved by adding the spatial derivatives of the amplitude of the acoustic field to the cost function (see \eqref{eq:crit2}).

\begin{figure}[t]
    \centering
    \begin{subfigure}[b]{0.49 \textwidth}
        \centering
        \includegraphics[width = \textwidth]{figs/amplitude_fitting_2.eps}
        \caption{The acoustic field shaped by minimizing criterion \eqref{eq:crit1}}
        \label{fig:slices_2a}
    \end{subfigure}
    \begin{subfigure}[b]{0.49 \textwidth}
        \centering
        \includegraphics[width = \textwidth]{figs/local_maximum_2.eps}
        \caption{The acoustic field shaped by minimizing criterion \eqref{eq:crit2}}
        \label{fig:slices_2b}
    \end{subfigure}
    \caption{Slices of the acoustic pressure field at $z = \SI{75}{\milli\metre}$. The required amplitude is \SI{2500}{\pascal} at $(x,y,z) = (45,45,75)$.}
    \label{fig:slices_2}
    \vspace{-2em}
\end{figure}

The acoustic field generated by gradient fitting is shown in \figref{fig:slices_3}.
While this method generates a low- and high-pressure area near the specified point, it can also create a second local maximum.
This second maximum may have an unpredictable effect on the manipulated object.

\begin{figure}[hb]
    \centering
    \includegraphics[width = .5\textwidth]{figs/gradient_fitting.eps}
    \caption{The acoustic field shaped by minimizing criterion \eqref{eq:crit3}. The required spatial derivatives with respect to $x$ and $y$ are both \SI{-7e8}{\pascal\squared\per\metre} at $(x,y,z) = (0,0,75)$.}
    \label{fig:slices_3}
    \vspace{-2em}
\end{figure}
\FloatBarrier

Another important aspect that needs to be addressed is the physical limitations of the acoustic field.
Minimizing the `amplitude fitting' criteria \eqref{eq:crit1} and \eqref{eq:crit2} can generate amplitudes of acoustic pressure as high as $3500$ pascals.
As mentioned above, such high amplitudes tend to break the surface tension of water and create bubbles, which cause random disturbances to the manipulated objects.
To prevent this, the generated amplitudes must be limited to $2500$ pascals.
We can enforce this limit by limiting the required amplitude since the amplitude of the resulting local maximum is close to the required value, as shown in Figures~\ref{fig:slices_1} and \ref{fig:slices_2}.

The spatial gradients of the acoustic pressure modulus are limited as well.
Through trial and error, I have concluded that the resulting spatial gradient is limited to approximately \SI{1e9}{\pascal\squared\per\metre} in all directions, \abbrv{i.e.,} the following inequality holds for the spatial derivatives:
\begin{equation}
    \left( \frac{\partial \left|P(x_i,y_i,z_i,\grvect{\Phi})\right|^2}{\partial x} \right)^2 +
        \left( \frac{\partial \left|P(x_i,y_i,z_i,\grvect{\Phi})\right|^2}{\partial y} \right)^2 \leq \left(10^9\right)^2\,.
\end{equation}

\section{Algorithm benchmarking}

To assess the performance of the proposed algorithms, I have created a benchmark program.
The program measures the execution time of individual algorithms on problems with one up to four fitted points, $256$ transducers, and various values for the required amplitudes or spatial gradients.

I have tested the LM algorithm with the three proposed criteria, as well as the Broyden–Fletcher–Goldfarb–Shanno (BFGS) algorithm used in my Bachelor's thesis \cite{bachelor_thesis}.
The results are shown in \figref{fig:benchmark}.
As you can see, the LM algorithm brings a significant improvement in execution time over BFGS.
In the following chapters, I will, therefore, use the LM algorithm with both amplitude and gradient fitting.

\begin{figure}[h]
    \vspace{2em}
    \centering
    \includegraphics[width = .7\textwidth]{figs/benchmark.eps}
    \caption{Results of algorithm benchmarking. The dashed lines go through medians, the error bars span from minima to maxima.}
    \label{fig:benchmark}
    \vspace{-0.75em}
\end{figure}